/*
 * Copyright (c) 1988, 1990 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: /usr/staff/martinh/tcpview/RCS/addrtoname.h,v 1.2 1993/04/22 20:43:07 martinh Exp $ (LBL)
 */

/* Name to address translation routines. */

#ifdef TCPVIEW
#ifdef __STDC__
char *etheraddr_string(u_char *);
char *etheraddr_str(u_char *, int);
char *etherproto_string(u_short);
char *etherproto_str(u_short, int);
char *tcpport_string(u_short);
char *udpport_string(u_short);
char *getname(u_char *, int);
char *intoa(u_long);
char *ipproto_string(u_short);
struct servent *GetServByName(char *, char *);
struct servent *GetServent(void);
void SetServent(int);
void EndServent(void);
#else
char *etheraddr_string();
char *etheraddr_str();
char *etherproto_string();
char *etherproto_str();
char *tcpport_string();
char *udpport_string();
char *getname();
char *intoa();
char *ipproto_string();
struct servent *GetServByName();
struct servent *GetServent();
void SetServent();
void EndServent();
#endif /* __STDC__ */
char *ipaddr_string();
extern void init_addrtoname();
extern void no_foreign_names();
#define etherproto_string(port) etherproto_str((u_short)port,nflag?ADDR_NUMERICAL:0)
#define ipaddr_str(x,f)	getname((u_char *)x,f)
#else
extern char *etheraddr_string();
extern char *etherproto_string();
extern char *tcpport_string();
extern char *udpport_string();
extern char *getname();
extern char *intoa();

extern void init_addrtoname();
extern void no_foreign_names();

#define ipaddr_string(p) getname((u_char *)(p))
#endif	/* TCPVIEW */






