/*
 * TCPVIEW
 *
 * Author:	Martin Hunt
 *		Networks and Distributed Computing
 *		Computing & Communications
 *		University of Washington
 *		Administration Building, AG-44
 *		Seattle, WA  98195
 *		Internet: martinh@cac.washington.edu
 *
 *
 * Copyright 1992 by the University of Washington
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appears in all copies and that both the
 * above copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the University of Washington not be
 * used in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  This software is made
 * available "as is", and
 * THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT LIMITATION ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND IN
 * NO EVENT SHALL THE UNIVERSITY OF WASHINGTON BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT
 * (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef lint
static char rcsid[] =
    "@(#) $Header: /usr/staff/martinh/tcpview/RCS/print.c,v 1.1 1993/04/22 20:33:56 martinh Exp $ (UW)";
#endif

#include <varargs.h>

extern char *StrPtr;
extern void *Xfile;
extern int Zflag;

int printf(va_alist)
     va_dcl
{
  va_list args;
  char *fmt;
  int num;

  va_start(args);
  fmt = va_arg(args, char *);
#ifdef TCPDUMP  
  (void)vprintf(fmt, args);
#else
#ifdef SYSTEM_V_VSPRINTF
  /* System 5 vsprintf() returns number of characters written */
  num = vsprintf(StrPtr,fmt,args); 
  if( Zflag )
    fprintf(Xfile,"%s",StrPtr);
  StrPtr += num; 
#else
  /* BSD vsprintf doesn't return anything useful */
  (void)vsprintf(StrPtr,fmt,args); 
  if( Zflag )
    fprintf(Xfile,"%s",StrPtr);
  while( *StrPtr) 
    StrPtr++;
#endif  /* SYSTEM_V_VSPRINTF */
#endif  /* TCPDUMP */

  va_end(args);
  return 0;
}

int fputs(s, foo)
char *s;
long foo;
{
  if( Zflag )
    fprintf(Xfile,"%s",s );
  strcpy( StrPtr, s );
  StrPtr += strlen( s );
  return 0;
}

int putchar(c)
int c;
{
  if( Zflag )
    fprintf(Xfile,"%c",c );
  *StrPtr++ = c;
  return 0;
}

int putc(x, foo)
int x;
long foo;
{
  if( Zflag )
    fprintf(Xfile,"%c",x );
  
  *StrPtr++ = x;
  return 0;
}
  




